<?php
/**
 * Droppics
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droppics
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

// no direct access
defined('_JEXEC') || die;

jimport('joomla.application.component.controllerform');

/**
 * Class DroppicsControllerPicture
 */
class DroppicsControllerPicture extends JControllerForm
{

    /**
     * Method to save a record.
     *
     * @param string $key    The name of the primary key of the URL variable.
     * @param string $urlVar The name of the URL variable if different from the primary key (sometimes required to avoid router collisions).
     *
     * @return void
     */
    public function save($key = null, $urlVar = null)
    {
        $recordId = JFactory::getApplication()->input->getInt('id');
        $context = $this->option . '.edit.' . $this->context;
        $this->holdEditId($context, $recordId);
        if (parent::save($key, $urlVar)) {
            $model = $this->getModel();
            $item = $model->getItem($recordId);
            $this->exitStatus(true, $item);
        } else {
            $this->exitStatus($this->getError());
        }
    }


    /**
     * Return a json response
     *
     * @param boolean $status Status
     * @param array   $datas  Array of datas to return with the json string
     *
     * @return void
     */
    private function exitStatus($status, $datas = array())
    {
        $response = array('response' => $status, 'datas' => $datas);
        echo json_encode($response);
        JFactory::getApplication()->close();
    }

    /**
     * Check permission to edit
     *
     * @param array  $data Data
     * @param string $key  Key
     *
     * @return boolean
     * @throws \Exception Throw when application can not start
     * @since  version
     */
    protected function allowEdit($data = array(), $key = 'id')
    {
        $canDo = DroppicsHelper::getActions();
        if (!$canDo->get('core.edit')) {
            if ($canDo->get('core.edit.own')) {
                $model = $this->getModel();
                $category = $model->getCategoryByPictureId($data[$key]);
                if ($category->created_user_id !== JFactory::getUser()->id) {
                    return false;
                }
            } else {
                return false;
            }
        }
        return true;
    }
}
