<?php
/**
 * Droppics
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droppics
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

// no direct access
defined('_JEXEC') || die;

/**
 * Class plgButtonDroppicsbtn
 */
class PlgButtonDroppicsbtn extends JPlugin
{
    /**
     * Do
     *
     * @var boolean
     */
    protected $do = true;

    /**
     * PlgButtonDroppicsbtn constructor.
     *
     * @param object $subject The object to observe
     * @param array  $config  An array that holds the plugin configuration
     */
    public function __construct(&$subject, $config)
    {

        parent::__construct($subject, $config);
        JLoader::register('DroppicsBase', JPATH_ADMINISTRATOR . '/components/com_droppics/classes/droppicsBase.php');
        if (!class_exists('DroppicsBase')) {
            $this->do = false;
        }
        $lang = JFactory::getLanguage();
        $lang->load('plg_editors-xtd_droppicsbtn', JPATH_PLUGINS . '/editors-xtd/droppicsbtn', null, true);
        $lang->load('plg_editors-xtd_droppicsbtn.sys', JPATH_PLUGINS . '/editors-xtd/droppicsbtn', null, true);

        // Access check.
        if (!JFactory::getUser()->authorise('core.manage', 'com_droppics')) {
            $this->do = false;
        }
    }


    /**
     * Display the button
     *
     * @param array $name A four element array of (code)
     *
     * @return object
     */
    public function onDisplay($name)
    {

        if (!$this->do) {
            return '';
        }

        $doc = JFactory::getDocument();
        if (JFactory::getApplication()->isClient('administrator')) {
            $doc->addStyleDeclaration('.button2-left .droppics {
                        background: url(' . JURI::root(true) . '/components/com_droppics/assets/images/j_button2_droppics.png) 100% 0 no-repeat;
                    }');
        }
        $doc->addStyleDeclaration('.icon-droppics:before {content: "\2f";}');
        $doc->addStyleDeclaration('.mce-window-head {border-bottom: 1px !important ;}');
        // set modal height in J4
        $css = '#'.$name.'_droppics_modal .modal-body { padding: 0; height: 90vh} #'.$name.'_droppics_modal .modal-body iframe, #droppics_modal .modal-body iframe  { height: 100%;} ';
        $doc->addStyleDeclaration($css);

        /*
         * Use the built-in element view to select the article.
         * Currently uses blank class.
         */
        $path = urlencode(JURI::root(true));

        if (JFactory::getApplication()->isClient('site')) {
            $link = 'index.php?option=com_droppics&amp;view=droppics&amp;tmpl=component&amp;' . JSession::getFormToken() . '=1&amp;e_name=' . $name . '&amp;caninsert=1&amp;template=droppicsfrontend&amp;path=' . $path;
        } else {
            $link = 'index.php?option=com_droppics&amp;view=droppics&amp;tmpl=component&amp;' . JSession::getFormToken() . '=1&amp;e_name=' . $name . '&amp;caninsert=1&amp;template=system&amp;path=' . $path;
        }

        $button = new JObject();
        $button->set('modal', true);
        $button->set('link', $link);
        $button->set('class', 'btn');
        $button->set('text', JText::_('PLG_DROPPICS_BUTTON'));
        $button->set('icon', 'image');
        $button->set('name', 'droppics');

        if (DroppicsBase::isJoomla30()) {
            $btnOptions = "{handler: 'iframe', size: {x: (window.getSize().x*90/100), y: (window.getSize().y-50)}}";
        } else {
            $btnOptions = array(
                'height'      => '700px',
                'width'       => '800px',
                'bodyHeight'  => '90',
                'modalWidth'  => '90',
            );
        }
        $button->set('options', $btnOptions);
        return $button;
    }
}
