<?php
/**
 * Droppics
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droppics
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

//-- No direct access
defined('_JEXEC') || die('=;)');


JLoader::register('droppicsPluginBase', JPATH_ADMINISTRATOR . '/components/com_droppics/classes/droppicsPluginBase.php');

/**
 * Bxslider Plugin.
 */
class PlgDroppicsBxslider extends droppicsPluginBase
{
    /**
     * Name
     *
     * @var string
     */
    public $name = 'bxslider';
    /**
     * Options
     *
     * @var object
     */
    protected $options;

    /**
     * On show Front Gallery
     *
     * @param array $options Options
     *
     * @return null|string
     */
    public function onShowFrontGallery($options)
    {
        $this->options = $options;
        if ($this->options['theme'] !== $this->name) {
            return null;
        }


        $doc = JFactory::getDocument();
        $params = JComponentHelper::getParams('com_droppics');

        $scripts = array();
        $stylesheets = array();

        $stylesheets[] = JURI::base('true') . '/plugins/droppics/bxslider/css/style.css';
        $stylesheets[] = JURI::base('true') . '/plugins/droppics/bxslider/css/swiper-bundle.min.css';
        $scripts[] = JURI::base('true') . '/plugins/droppics/bxslider/js/jquery.fitvids.js';
        $scripts[] = JURI::base('true') . '/plugins/droppics/bxslider/js/swiper-bundle.min.js';
        $scripts[] = JURI::base('true') . '/plugins/droppics/bxslider/js/script.js';

        $declaration =
            "if(typeof(Droppics)=='undefined'){"
            . '     Droppics={};'
            . '}'
            . "Droppics.ajaxurl = '" . JUri::root() . "';";
        $doc->addScriptDeclaration($declaration);

        $headLoading = '';
        if ($this->options['from_plugin'] === true) {
            $doc->addScript(JURI::base('true') . '/components/com_droppics/assets/js/droppicsHelper.js');
            JLoader::register('DroppicsBase', JPATH_ADMINISTRATOR . '/components/com_droppics/classes/droppicsBase.php');
            JHtml::_('jquery.framework');
            foreach ($scripts as $script) {
                $doc->addScript($script);
            }
            foreach ($stylesheets as $stylesheet) {
                $doc->addStyleSheet($stylesheet);
            }
        } else {
            $files = array();
            foreach ($scripts as $script) {
                $files[] = '["' . $script . '","js"]';
            }
            foreach ($stylesheets as $stylesheet) {
                $files[] = '["' . $stylesheet . '","css"]';
            }
            $files = implode(',', $files);
            $headLoading .= "loadHeadFiles('[" . $files . "]');";
        }


        $content = '';
        $pager = '';
        $ij = 0;
        $listchid = '';
        if (!empty($this->options['pictures']) || !empty($this->options['categories'])) {
            $picture_reponsive = droppicsBase::getParam('picture_reponsive', 0);
            if ($this->options['listchid']) {
                $listchid = implode(',', $this->options['listchid']);
            }
            $content .= '<div id="droppicsgallery' . $this->options['id_gallery'] . '" class="droppicsgallerybxslider droppicsgallery" data-shownav="' . droppicsBase::loadValue($options['params'], 'bxslider_show_nav', '1') . '" data-showbotnav="' . droppicsBase::loadValue($options['params'], 'bxslider_show_bottom_nav', '2') . '" data-autostart="' . droppicsBase::loadValue($options['params'], 'bxslider_autostart', '0') . '" data-pause="' . droppicsBase::loadValue($options['params'], 'bxslider_pause', '4000') . '" data-mode="' . droppicsBase::loadValue($options['params'], 'bxslider_mode', '0') . '" data-adaptive="' . droppicsBase::loadValue($options['params'], 'bxslider_adaptive_height', '1') . '"data-onhover="' . droppicsBase::loadValue($options['params'], 'bxslider_pause_on_hover', '0') . '" data-id="' . $this->options['id_gallery'] . '" data-listchid="' . $listchid . '">';
            if (!empty($this->options['pictures'])) {
                $large_img_size = droppicsBase::getParam('lightbox_img_size', 'large');
                if ($large_img_size !== 'full') {
                    $large_img_size = 'large';
                }
                $largePictureBaseUrl = COM_MEDIA_BASEURL . '/' . $this->rootFolder() . '/' . $this->options['pictures'][0]->id_gallery . '/' . $large_img_size . '/';

                $content .= '<div class="swiper-container droppicsSwiperMain droppicsSwiper-Main'.$this->options['id_gallery'].'"><div class="swiper-wrapper">';
                foreach ($this->options['pictures'] as $key => $picture) {
                    $pparams = json_decode($picture->picture_params);
                    $custom_link = '';
                    if (is_object($pparams) && isset($pparams->follow_custom_link) && $pparams->follow_custom_link === '1' && $pparams->imgp_click !== 'lightbox' && $pparams->imgp_click !== 'nothing') {
                        if ($pparams->imgp_click === 'article') {
                            $custom_link = JRoute::_($pparams->acticle_link, false);
                        } elseif ($pparams->imgp_click === 'menuitem') {
                            $custom_link = JRoute::_($pparams->click_content_menuitem, false);
                        } elseif ($pparams->imgp_click === 'custom') {
                            $custom_link = $pparams->custom_link;
                        }
                    }

                    $content .= '<div class="wimg swiper-slide" data-index="' . $ij . '">';
                    $srcSet = droppicsBase::getUrlResponsive($picture->id_gallery, '/' . $large_img_size . '/' . $picture->file, $picture->filever, $picture->file);
                    if (isset($pparams->is_video) && (int)$pparams->is_video === 1) {
                        $vwidth = (int)$params->get('video_width', 640);
                        if (isset($pparams->ratio) && $pparams->ratio) {
                            $height = $vwidth / $pparams->ratio;
                        } else {
                            $height = 390;
                        }
                        $content .= '<div class="videoWrapper"><iframe src="' . $pparams->directLink . '" width="' . $vwidth . '" height="' . $height . '"  frameborder="0" webkitAllowFullScreen mozallowfullscreen allowFullScreen  title="' . $picture->title . '" ></iframe></div>';
                    } elseif ($custom_link) {
                        if (isset($pparams->imgp_click_target) && $pparams->imgp_click_target === '_blank') {
                            $target = ' target="_blank"';
                        } else {
                            $target = '';
                        }
                        $content .= '<a href="' . $custom_link . '"' . $target . '><img src="' . $largePictureBaseUrl . $picture->filever . '" '
                            . $srcSet . ' alt="' . $picture->alt . '" title="' . $picture->title . '" data-thumb="' . COM_MEDIA_BASEURL . '/' . $this->rootFolder() . '/' . $picture->id_gallery . '/thumbnails/' . $picture->filever . '"/></a>';
                    } else {
                        $content .= '<img src="' . $largePictureBaseUrl . $picture->filever . '"' . $srcSet . ' alt="' . $picture->alt . '" title="' . $picture->title . '" data-thumb="' . COM_MEDIA_BASEURL . '/' . $this->rootFolder() . '/' . $picture->id_gallery . '/thumbnails/' . $picture->filever . '"'
                            . ' />';
                    }

                    /*show thumbnail*/
                    if (droppicsBase::loadValue($this->options['params'], 'bxslider_show_bottom_nav', '2') === '2') {
                        $urlbase = COM_MEDIA_BASEURL . '/' . $this->rootFolder() . '/' . $picture->id_gallery . '/responsive/' . $picture->filever;
                        $url = COM_MEDIA_BASE . '/' . $this->rootFolder() . '/' . $picture->id_gallery . '/responsive/' . $picture->filever;
                        $link_mini = '' . (file_exists($url) ? $urlbase : COM_MEDIA_BASEURL . '/' . $this->rootFolder() . '/' . $picture->id_gallery . '/thumbnails/' . $picture->filever);
                        if (isset($pparams->is_video) && (int)$pparams->is_video === 1) {
                            $pager .= '<div class="swiper-slide"><img src="' . COM_MEDIA_BASEURL . '/' . $this->rootFolder() . '/' . $picture->id_gallery . '/thumbnails/' . $picture->filever . '" alt="' . $picture->alt . '" title="' . $picture->title . '" /><i class="video"></i></div>';
                        } else {
                            $pager .= '<div class="swiper-slide"><img src="' . COM_MEDIA_BASEURL . '/' . $this->rootFolder() . '/' . $picture->id_gallery . '/thumbnails/' . $picture->filever . '" alt="' . $picture->alt . '" title="' . $picture->title . '" /></div>';
                        }
                    }
                    if (trim(droppicsBase::loadValue($pparams, 'bxslider_image_html', '')) !== '') {
                        $content .= '<div class="bxsliderhtml" style="'

                            . '             top: ' . droppicsBase::loadValue($pparams, 'bxslider_image_top', '80') . '%;'
                            . '             left: ' . droppicsBase::loadValue($pparams, 'bxslider_image_left', '0') . '%;'
                            . '             width: ' . droppicsBase::loadValue($pparams, 'bxslider_image_width', '100') . '%;'
                            . '             height: ' . droppicsBase::loadValue($pparams, 'bxslider_image_height', '20') . '%;'
                            . '             background-color: ' . $this->hex2rgba(droppicsBase::loadValue($pparams, 'bxslider_image_bgcolor', 'transparent'), droppicsBase::loadValue($pparams, 'bxslider_image_transparency', '90') / 100) . ';'
                            . '                 ">' . droppicsBase::loadValue($pparams, 'bxslider_image_html', '') . '</div>';
                    }
                    $content .= '</div>';
                    $ij++;
                }
                $content .= '</div>';
                if (droppicsBase::loadValue($options['params'], 'bxslider_show_nav', '1')) {
                    $content .= '<div class="swiper-button-next"></div>';
                    $content .= '<div class="swiper-button-prev"></div>';
                }

                if (droppicsBase::loadValue($this->options['params'], 'bxslider_show_bottom_nav', '2') === '1') {
                    $content .= '<div class="swiper-pagination">';
                    $content .= '</div>';
                }

                if (droppicsBase::loadValue($this->options['params'], 'bxslider_show_bottom_nav', '2') === '2') {
                    $content .= '<div thumbsSlider="" class="swiper-container droppicsSwiperPager droppicsSwiper-pagination'. $this->options['id_gallery'] .'" ><div class="swiper-wrapper">';
                    $content .= $pager;
                    $content .= '</div></div>';
                }
            }
            $content .= '</div>';

            if (!empty($this->options['categories']) && droppicsBase::loadValue($options['params'], 'bxslider_show_subcategories', '1')) {
                $subGShowImages = droppicsBase::getParam('sub_galleries_show', '1');
                if ($subGShowImages === '1') {
                    $classSub = 'show';
                } else {
                    $classSub = '';
                }
                $content .= '<div class="droppicscats ' . $classSub . '">';


                $subGalleriesTitle = droppicsBase::getParam('sub_galleries_title', '1');
                if ($subGalleriesTitle === '1') {
                    $content .= '<h2>' . JText::_('COM_DROPPICS_SUBCGALLERIES') . '</h2>';
                }
                $catimage = 0;
                if ($this->options['from_plugin'] !== true && !empty($this->options['parent'])) {
                    if ($this->options['parent']->id_picture === null) {
                        $params = JComponentHelper::getParams('com_droppics');
                        $src = JURI::base() . $params->get('catimage', 'components/com_droppics/assets/images/back-gallery.png');
                        $srcSet = '';
                        $catimage = 1;
                        $alt = $this->options['parent']->category_title;
                        $title = '';
                    } else {
                        $src = COM_MEDIA_BASEURL . '/' . $this->rootFolder() . '/' . $this->options['parent']->id_category . '/thumbnails/' . $this->options['parent']->picture_ver;
                        $srcSet = droppicsBase::getUrlResponsive($this->options['parent']->id_category, '/thumbnails/' . $this->options['parent']->picture_file, $this->options['parent']->picture_ver, $this->options['parent']->picture_file);
                        $catimage = 0;
                        $title = $this->options['parent']->picture_title;
                        $alt = $this->options['parent']->picture_alt;
                    }
                    if (!isset($src) || !getimagesize($src)) {
                        $src = JURI::base() . 'components/com_droppics/assets/images/back-gallery.png';
                        $srcSet = '';
                        $catimage = 1;
                    }
                    if (!isset($title)) {
                        $title = pathinfo($src, PATHINFO_FILENAME);
                    }
                    if (!isset($alt)) {
                        $alt = pathinfo($src, PATHINFO_FILENAME);
                    }

                    $content .= '<div class="wcat wimg wparent">';
                    $content .= '<a class="droppicscatslink" data-id="' . $this->options['parent']->id_category . '" href="" data-categorytitle="' . $this->options['parent']->category_title . '" data-catimage ="' . $catimage . '" >';
                    $content .= '<img class="img" src="' . $src . '" ' . $srcSet . ' alt="' . $alt . '" title="' . $title . '" />';
                    $content .= '</a>';
                    $content .= '<span>' . JText::_('COM_DROPPICS_BACK_TO') . ' ' . $this->options['parent']->category_title . '</span>';
                    $content .= '</div>';
                    $content .= '<div class="clr"></div>';
                }
                foreach ($this->options['categories'] as $category) {
                    $srcSet = droppicsBase::getUrlResponsive($category->id_category, '/thumbnails/' . $category->picture_file, $category->picture_ver, $category->picture_file);
                    $content .= '<div class="wcat wimg">';
                    $content .= '<a class="droppicscatslink" data-id="' . $category->id_category . '" href="' . COM_MEDIA_BASEURL . '/' . $this->rootFolder() . '/' . $category->id_category . '/' . $category->picture_ver . '" data-categorytitle="' . $category->category_title . '">';
                    $content .= '<img class="img" src="' . COM_MEDIA_BASEURL . '/' . $this->rootFolder() . '/'
                        . $category->id_category
                        . '/thumbnails/' . $category->picture_ver . '" ' . $srcSet . ' alt="' . $category->picture_alt . '" title="' . $category->picture_title . '" />';
                    $content .= '</a>';
                    $content .= '<span>' . $category->category_title . '</span>';
                    $content .= '</div>';
                }
                $content .= '</div>';
                $content .= '<div class="clr"></div>';
            } else {
                $params = JComponentHelper::getParams('com_droppics');
                $catimage = $params->get('catimage', 'components/com_droppics/assets/images/back-gallery.png');
                $src = JURI::base() . $params->get('catimage', 'components/com_droppics/assets/images/back-gallery.png');
                if (!$catimage) {
                    $src = JURI::base() . 'components/com_droppics/assets/images/back-gallery.png';
                }
                $alt = pathinfo($src, PATHINFO_FILENAME);
                $title = '';
                if ($this->options['from_plugin'] !== true && isset($this->options['parent'])) {
                    $content .= '<div class="droppicscats">';
                    $content .= '<div class="wcat wimg wparent">';
                    $content .= '<a class="droppicscatslink" data-id="' . $this->options['parent']->id_category . '" href="" data-categorytitle="' . $this->options['parent']->category_title . '" data-catimage ="1" >';
                    $content .= '<img class="img" src="' . $src . '" alt="' . $alt . '" title="' . $title . '" />';
                    $content .= '</a>';
                    $content .= '<span>' . JText::_('COM_DROPPICS_BACK_TO') . ' ' . $this->options['parent']->category_title . '</span>';
                    $content .= '</div>';
                    $content .= '</div>';
                    $content .= '<div class="clr"></div>';
                }
            }
            //check hash url category
            if ($this->options['from_plugin'] === true) {
                $content .= '<script type="text/javascript">var initGallery = true; var ' . $this->name . '_category_id= ' .
                    $this->options['id_gallery'] . '; var ' . $this->name . '_hash = window.location.hash; ' . $this->name . '_hash = ' .
                    $this->name . '_hash.replace(\'#\',\'\'); var ' . $this->name . '_cat_id_click= \'\';
                if (' . $this->name . '_hash != \'\') {
                    var hasha = ' . $this->name . '_hash.split(\'-\');
                    var re = new RegExp("^([0-9]+)$");
                    var hash_category_id = hasha[0];        
                    if (!re.test(hash_category_id)) { hash_category_id = 0;}
                    if(hash_category_id) {initGallery = false; }
                }
                  </script>';
            } else {
                $content .= '<script type="text/javascript"> var ' . $this->name . '_cat_id_click= ' . $this->options['id_gallery'] . ';</script>';
            }
            if (empty($this->options['categories']) && empty($this->options['parent']) && $this->options['from_plugin'] === true) {
                //Include style in the head with joomla
                $this->addStyleDeclaration($this->options, false);
            } else {
                //Include style in the head dynamically
                $headLoading .= $this->addStyleDeclaration($this->options, true);
            }

            if ($headLoading !== '') {
                $headLoading = '<script type="text/javascript">' . $headLoading . '</script>';
            }
            $content .= $headLoading;

            $content .= '</div>';
        }
        return $content;
    }

    /**
     * Add StyleDeclaration
     *
     * @param array   $options Options
     * @param boolean $dynamic Dynamic
     *
     * @return string
     */
    protected function addStyleDeclaration($options, $dynamic = false)
    {
        $picture_reponsive = droppicsBase::getParam('picture_reponsive', 0);
        $params = $options['params'];

        $style = '';

        $style .= '#droppicsgallery' . $this->options['id_gallery'] . ' .droppicsSwiperMain {';
        if (droppicsBase::loadValue($params, 'bxslider_align_center', 0) === 1) {
            $style .= 'margin-left: auto;';
            $style .= 'margin-right: auto;';
        }
        if (droppicsBase::loadValue($params, 'bxslider_width', 0) > 0) {
            $style .= '     width : ' . droppicsBase::loadValue($params, 'bxslider_width') . 'px;';
        }
        if (droppicsBase::loadValue($params, 'bxslider_background', '') !== '') {
            $style .= '     background-color : ' . droppicsBase::loadValue($params, 'bxslider_background') . ';';
        } else {
            $style .= '     background-color : transparent;';
        }

        $style .= '}';

        if (droppicsBase::loadValue($params, 'bxslider_height', 0) > 0) {
            $style .= ' @media screen and (min-width: 800px) { #droppicsgallery' . $this->options['id_gallery'] . ' .droppicsSwiperMain {  height : ' . droppicsBase::loadValue($params, 'bxslider_height') . 'px !important; } }';
        } else {
            $style .= ' #droppicsgallery' . $this->options['id_gallery'] . ' .droppicsSwiperMain > .swiper-wrapper { max-height : 80vh;}';
            $style .= ' #droppicsgallery' . $this->options['id_gallery'] . ' .droppicsSwiperMain > .swiper-wrapper img { max-height : 80vh;}';
        }

        if (droppicsBase::loadValue($params, 'bxslider_fitwidth', '0') !== '0') {
            $style .= '#droppicsgallery' . $this->options['id_gallery'] . ' .droppicsSwiperMain .swiper-slide.wimg img {';
            $style .= '     width : 100%;';
            $style .= '}';
        }

        $style .= '#droppicsgallery' . $this->options['id_gallery'] . '.droppicsgallerybxslider .droppicscats .wimg {';
        $height = droppicsBase::getParam('thumbnail_height', '180');
        $style .= 'height : ' . $height . 'px;';
        $width = droppicsBase::getParam('thumbnail_width', '180');
        $style .= 'width : ' . $width . 'px;';
        $style .= '}';

        if ($dynamic === false) {
            $doc = JFactory::getDocument();
            $doc->addStyleDeclaration($style);
        } else {
            return 'loadHeadStyle("' . $style . '","droppicsgalleryStyle' . $options['id_gallery'] . '");';
        }
        return '';
    }

    /**
     * Add Admin Script Declaration
     *
     * @return string
     */
    protected function addAdminScriptDeclaration()
    {
        $script = '';
        $script .= '#preview .highlight {';
        $script .= 'height:' . (droppicsBase::getParam('thumbnail_height', '180') - 62) . 'px;';
        $script .= 'width:' . (droppicsBase::getParam('thumbnail_width', '180') - 15) . 'px;';
        $script .= '}';

        return '<style type="text/css">' . $script . '</style>';
    }


    /**
     * Convert hexdec color string to rgb(a) string
     * From http://mekshq.com/how-to-convert-hexadecimal-color-code-to-rgb-or-rgba-using-php/
     *
     * @param string  $color   Color
     * @param boolean $opacity Opacity
     *
     * @return string
     */
    private function hex2rgba($color, $opacity = false)
    {
        $default = 'rgb(0,0,0)';

        //Return default if no color provided
        if (empty($color)) {
            return $default;
        }

        //Sanitize $color if "#" is provided
        if ($color[0] === '#') {
            $color = substr($color, 1);
        }

        //Check if color has 6 or 3 characters and get values
        if (strlen($color) === 6) {
            $hex = array($color[0] . $color[1], $color[2] . $color[3], $color[4] . $color[5]);
        } elseif (strlen($color) === 3) {
            $hex = array($color[0] . $color[0], $color[1] . $color[1], $color[2] . $color[2]);
        } else {
            return $default;
        }

        //Convert hexadec to rgb
        $rgb = array_map('hexdec', $hex);

        //Check if opacity is set(rgba or rgb)
        if ($opacity && $opacity !== 'transparent') {
            if (abs($opacity) > 1) {
                $opacity = 1.0;
            }
            $output = 'rgba(' . implode(',', $rgb) . ',' . $opacity . ')';
        } else {
            $output = 'rgb(' . implode(',', $rgb) . ')';
        }

        //Return rgb(a) color string
        return $output;
    }
}
