<?php
/**
 * Droppics
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droppics
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

//no direct accees
defined('_JEXEC') || die('restricted aceess');

// phpcs:disable Squiz.Classes.ValidClassName.NotCamelCaps -- Default joomla core class name rule
/***
 * Droppics gallery addon cls
 */
class SppagebuilderAddonDroppics_gallery extends SppagebuilderAddons
{
    /**
     * Render for gallery addon
     *
     * @return string
     */
    public function render()
    {

        $class = (isset($this->addon->settings->class) && $this->addon->settings->class) ? ' ' . $this->addon->settings->class : '';
        $catid = (isset($this->addon->settings->catid) && $this->addon->settings->catid) ? $this->addon->settings->catid : '';

        $output = '';
        if ($catid) {
            $gallery_id = str_replace('gallery-', '', $catid);
            $output .= '<div class="sppb-addon sppb-addon-droppics-gallery' . $class . '">';

            $text = '<img src="/components/com_droppics/assets/images/wptm_placeholder_table.svg" data-droppicsgallery="'.$gallery_id.'" />';
            $html = JHtml::_('content.prepare', $text);
            if ($html) {
                $output .= $html;
            } else {
                $output .= 'Empty content';
            }

            $output .= '</div>';
        } else {
            $output .= '<div class="sppb-addon sppb-addon-droppics-gallery' . $class . '">';
            $output .= '<img style="background: url(\''. JURI::root().'/components/com_droppics/assets/images/gallery.png\') no-repeat scroll center center #D6D6D6; height: 200px; border-radius: 10px; width: 99%;" src="'. JURI::root() . 'components/com_droppics/assets/images/t.gif" />';
            $output .= '<span style="font-size: 13px; text-align: center;">Please select a Droppics content to activate the preview</span>';
            $output .= '</div>';
        }

        return $output;
    }

    /**
     * Template for gallery addon
     *
     * @return string
     */
    public static function getTemplate()
    {

        $output = '';
        $output .= '<div class="sppb-addon sppb-addon-droppics-gallery edit-view" >';
        $output .= '<img style="background: url(\''. JURI::root().'/components/com_droppics/assets/images/gallery.png\') no-repeat scroll center center #D6D6D6; height: 200px; border-radius: 10px; width: 99%;" src="'. JURI::root() . 'components/com_droppics/assets/images/t.gif" />';
        $output .= '<span style="font-size: 13px; text-align: center;">Open preview to see the gallery</span>';
        $output .= '</div>';

        return $output;
    }

    /**
     * CSS for gallery addon
     *
     * @return string
     */
    public function css()
    {
        $addon_id = '#sppb-addon-' . $this->addon->id;

        $style = '';
        $style_sm = '';
        $style_xs = '';

        $style .= (isset($this->addon->settings->addon_text_transform) && $this->addon->settings->addon_text_transform) ? 'text-transform: ' . $this->addon->settings->addon_text_transform  . '; ' : '';

        if (isset($addon->settings->addon_font_style->italic) && $addon->settings->addon_font_style->italic) {
            $style .= 'font-style: italic;';
        }

        if (isset($addon->settings->addon_font_style->uppercase) && $addon->settings->addon_font_style->uppercase) {
            $style .= 'text-transform: uppercase;';
        }

        if (isset($addon->settings->addon_font_style->weight) && $addon->settings->addon_font_style->weight) {
            $style .= 'font-weight: ' . $addon->settings->addon_font_style->weight . ';';
        }

        $css = '';
        if ($style) {
            $css .= $addon_id . ' .sppb-addon-title {' . $style . '}';
        }

        if ($style_sm) {
            $css .= '@media (min-width: 768px) and (max-width: 991px) {';
                $css .= $addon_id . ' .sppb-addon-title {' . $style_sm . '}';
            $css .= '}';
        }

        if ($style_xs) {
            $css .= '@media (max-width: 767px) {';
                $css .= $addon_id . ' .sppb-addon-title {' . $style_xs . '}';
            $css .= '}';
        }

        return $css;
    }
}
