<?php
/**
 * Droppics
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droppics
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */


defined('_JEXEC') || die;
use Joomla\CMS\Helper\ContentHelper;

/**
 * Class DroppicsHelper
 */
class DroppicsHelper
{

    /**
     * A cache for the available actions.
     *
     * @var JObject $actions
     */
    protected static $actions;


    /**
     * Configure the Linkbar.
     *
     * @param string $vName The name of the active view.
     *
     * @return void
     */
    public static function addSubmenu($vName)
    {
//      JSubMenuHelper::addEntry(
//          JText::_('COM_MESSAGES_ADD'),
//          'index.php?option=com_messages&view=message&layout=edit',
//          $vName == 'message'
//      );
//
//      JSubMenuHelper::addEntry(
//          JText::_('COM_MESSAGES_READ'),
//          'index.php?option=com_messages',
//          $vName == 'messages'
//      );
    }


    /**
     * Gets a list of the actions that can be performed.
     *
     * @return JObject
     *
     * @todo Refactor to work with notes
     */
    public static function getActions()
    {
        if (empty(self::$actions)) {
            self::$actions = ContentHelper::getActions('com_droppics', 'category');
        }

        return self::$actions;
    }

    /**
     * Method to get a list of cats
     *
     * @return array  The field option objects.
     *
     * @since 3.1
     */
    public static function droppicsCatList()
    {
        $listArray = array('' => 'Select gallery');

        JLoader::register('DroppicsHelper', JPATH_ADMINISTRATOR . '/components/com_dropfiles/helpers/droppics.php');
        $path_model = JPATH_ROOT . '/administrator/components/com_droppics/models/';
        JModelLegacy::addIncludePath($path_model, 'DroppicsModelCategories');
        $modelCategories = JModelLegacy::getInstance('categories', 'droppicsModel');
        $all_cats = $modelCategories->getItems();

        $totalCat = count($all_cats);
        for ($i = 0; $i < $totalCat; $i++) {
            $listArray['gallery-'.$all_cats[$i]->id] = str_repeat('-', ($all_cats[$i]->level - 1)) . ' ' . $all_cats[$i]->title;
        }

        return $listArray;
    }

    /**
     * Get theme of a category
     *
     * @param integer $catID Category ID
     *
     * @return string
     */
    public static function getGalleryTheme($catID)
    {
        JModelLegacy::addIncludePath(JPATH_ADMINISTRATOR . '/components/com_droppics/models/', 'droppicsModel');
        $modelCategory = JModelLegacy::getInstance('Category', 'droppicsModel');
        $theme = $modelCategory->getCategoryTheme($catID);
        if (!$theme) {
            $theme = 'default';
        }

        return $theme;
    }
}
