<?php
/**
 * Droppics
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droppics
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

// No direct access
defined('_JEXEC') || die;

/**
 * Gallery Table class
 */
class DroppicsTableGallery extends JTable
{
    /**
     * Constructor
     *
     * @param JDatabase $db A database connector object
     */
    public function __construct(&$db)
    {
        parent::__construct('#__droppics', 'id', $db);
    }

    /**
     * Overloaded bind function to pre-process the params.
     *
     * @param array  $array  Named array
     * @param string $ignore Ignore
     *
     * @return null|string null is operation was satisfactory, otherwise returns an error
     */
    public function bind($array, $ignore = '')
    {
        if (isset($array['params']) && is_array($array['params'])) {
            $registry = new JRegistry();
            $registry->loadArray($array['params']);
            $array['params'] = (string)$registry;
        }
        return parent::bind($array, $ignore);
    }
}
