<?php
/**
 * System message
 *
 * @package    Joomla.Site
 * @subpackage Template.protostar
 *
 * @copyright Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license   GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') || die;

$msgList = $displayData['msgList'];

$alert = array('error' => 'alert-error', 'warning' => '', 'notice' => 'alert-info', 'message' => 'alert-success');
?>
<div id="system-message-container">
    <?php if (is_array($msgList) && !empty($msgList)) : ?>
        <div id="system-message">
            <?php foreach ($msgList as $type => $msgs) : ?>
                <div class="alert <?php echo $alert[$type]; ?>">
                    <?php // This requires JS so we should add it trough JS. Progressive enhancement and stuff. ?>
                    <a class="close" data-dismiss="alert">×</a>

                    <?php if (!empty($msgs)) : ?>
                        <h4 class="alert-heading"><?php echo JText::_($type); ?></h4>
                        <div>
                            <?php foreach ($msgs as $msg) : ?>
                                <p class="alert-message"><?php echo $msg; ?></p>
                            <?php endforeach; ?>
                        </div>
                    <?php endif; ?>
                </div>
            <?php endforeach; ?>
        </div>
    <?php endif; ?>
</div>
