<?php
/**
 * Droppics
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droppics
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

// No direct access.
defined('_JEXEC') || die;
$doc = JFactory::getDocument();
$declaration =
    ' .subhead .container-fluid, .container-fluid.container-main {'
    . '   padding-right: 20px !important;'
    . '   padding-left: 20px !important;'
    . '}'
    . '';
$doc->addStyleDeclaration($declaration);
?>

<div class="wrap seo_extended_table_page">
    <div id="icon-edit-pages" class="icon32 icon32-posts-page"></div>
    <form id="adminForm" name="adminForm"
          action="<?php echo JRoute::_('index.php?option=com_droppics&view=imagesinfo'); ?>" method="post">
        <div class="tablenav top dp_image_seo">
            <input type="hidden" name="page" value="metaseo_image_meta">
            <div class="alignleft actions bulkactions">
                <label for="filter-by-date" class="screen-reader-text">Filter by date</label>
                <select name="filter[gallery_id]" id="filter_gallery_id" class="metaseo-filter">
                    <?php
                    $content = '';
                    if ($this->f_gallery_id === '0' || $this->f_gallery_id === '') {
                        $content .= '<option selected ="selected" value ="0">' . JText::_('COM_DROPPICS_VIEW_ALL_CATEGORY') . '</option >';
                    } else {
                        $content .= '<option value ="0">' . JText::_('COM_DROPPICS_VIEW_ALL_CATEGORY') . '</option >';
                    }
                    if (!empty($this->categories)) {
                        $totalCategories = count($this->categories);
                        for ($index = 0; $index < $totalCategories; $index++) {
                            if ($index + 1 !== count($this->categories)) {
                                $nextlevel = $this->categories[$index + 1]->level;
                            } else {
                                $nextlevel = 0;
                            }
                            $selected = '';
                            $space_str = '';
                            if ($nextlevel > $this->categories[$index]->level) {
                                if (($this->categories[$index]->level - 1) > 0) {
                                    $space_str = str_repeat('&nbsp;', $this->categories[$index]->level - 1);
                                }
                            } elseif ($nextlevel === $this->categories[$index]->level) {
                                $space_str = str_repeat('&nbsp;', $nextlevel - 1);
                            } else {
                                if (($this->categories[$index]->level - 1) > 0) {
                                    $space_str = str_repeat('&nbsp;', $this->categories[$index]->level - 1);
                                }
                            }


                            if ($this->categories[$index]->id === $this->f_gallery_id) {
                                $content .= '<option selected ="selected" value = ' .
                                    $this->categories[$index]->id . '>' . $space_str . ''
                                    . $this->categories[$index]->title . '</option >';
                            } else {
                                $content .= '<option value = ' . $this->categories[$index]->id . '> ' . $space_str . ''
                                    . $this->categories[$index]->title . '</option >';
                            }
                        }
                        echo $content;
                    } ?>
                </select>

                <button name="filter_date_action" id="image-submit" class="button">
                    <span class="icon-publish"></span>
                    <?php echo JText::_('COM_DROPPICS_VIEW_IMAGESINFO_FILTER') ?>
                </button>
            </div>
            <div class="alignleft">
                <select name="filter[image_mbulk_copy]" id="filter_image_mbulk_copy" class="mbulk_copy">
                    <option value="all"><?php echo JText::_('COM_DROPPICS_VIEW_ALL_IMAGE') ?></option>
                    <option value="bulk-copy-title-alt"><?php echo JText::_('COM_DROPPICS_VIEW_SELECTED_IMAGE') ?></option>
                </select>
                <button name="image_do_copy_alt" class="button btn_do_copy image_do_copy_alt">
                    <span class="icon-publish"></span>
                    <?php echo JText::_('COM_DROPPICS_VIEW_IMAGESINFO_COPYALT') ?>
                </button>
                <button name="image_do_copy_title" class="button btn_do_copy image_do_copy_title">
                    <span class="icon-publish"></span>
                    <?php echo JText::_('COM_DROPPICS_VIEW_IMAGESINFO_COPYTITLE') ?>
                </button>

                <span class="spinner"></span></div>
            <input type="hidden" name="page" value="metaseo_image_meta">
            <div style="float:right;margin-left:8px;"></div>
            <p class="search-box">
                <input type="search" id="filter_search_drp" name="filter[search_drp]"
                       value="<?php echo $this->escape($this->f_search_drp); ?>">
                <input type="hidden" id="filter_order_by" name="filter[order_by]"
                       value="<?php echo $this->escape($this->f_order_by); ?>">
                <button name="search" id="search-submit" class="button">
                    <span class="icon-search"></span>
                    <?php echo JText::_('COM_DROPPICS_VIEW_IMAGESINFO_SEARCH') ?>
                </button>
            </p>
            <br class="clear">
        </div>
        <table class="wp-list-table widefat fixed striped metaseo_images">
            <thead>
            <tr>
                <th scope="col" id="cb" class="manage-column column-cb check-column" style="padding:8px 10px;"><label
                            class="screen-reader-text" for="cb-select-all-1">Select All</label>
                    <input id="cb-select-all-1" type="checkbox" style="margin:0;"></th>
                <th scope="col" id="col_id" class="manage-column column-col_id" style="" colspan="1"><a href="#"
                                                                                                        onclick="return false;"
                                                                                                        class="js-stools-column-order"
                                                                                                        data-name="id">ID<span></span></a>
                </th>
                <th scope="col" id="col_image" class="manage-column column-col_image" style=""
                    colspan="3"><?php echo JText::_('COM_DROPPICS_SEO_OPTIMIZER_IMAGE'); ?></th>
                <th scope="col" id="col_image" class="manage-column column-col_image" style=""
                    colspan="3"><?php echo JText::_('COM_DROPPICS_SEO_OPTIMIZER_SIZE'); ?></th>
                <th scope="col" id="col_image_name" class="manage-column column-col_image_name sortable asc" style=""
                    colspan="4"><a href="#" onclick="return false;" class="js-stools-column-order"
                                   data-name="name"><?php echo JText::_('COM_DROPPICS_SEO_OPTIMIZER_NAME'); ?>
                        <span></span></a></th>
                <th scope="col" id="col_image_alternative" class="manage-column column-col_image_alternative" style=""
                    colspan="3"><a href="#" onclick="return false;" class="js-stools-column-order"
                                   data-name="alt"><?php echo JText::_('COM_DROPPICS_SEO_OPTIMIZER_ALTTEXT'); ?>
                        <span></span></a></th>
                <th scope="col" id="col_image_title" class="manage-column column-col_image_title sortable asc" style=""
                    colspan="3"><a href="#" onclick="return false;" class="js-stools-column-order"
                                   data-name="title"><?php echo JText::_('COM_DROPPICS_SEO_OPTIMIZER_TITLE'); ?>
                        <span></span></a></th>
                <th scope="col" id="col_image_desc" class="manage-column column-col_image_desc" style=""
                    colspan="3"><?php echo JText::_('COM_DROPPICS_SEO_OPTIMIZER_CAPTION'); ?></th>
            </tr>
            </thead>
            <tbody>
            <?php echo $this->loadTemplate('list'); ?>
            </tbody>
            <tfoot>
            </tfoot>
        </table>
        <div class="tablenav bottom">
            <input type="hidden" name="page" value="metaseo_image_meta">
            <div style="float:right;margin-left:8px;">
                <input type="number" required="" min="1" value="<?php echo $this->f_limit_drp ?>" maxlength="3"
                       name="list[limit]"
                       id="list_limit" class="metaseo_imgs_per_page screen-per-page" max="999" step="1">
                <button name="btn_perpage" class="button_perpage button" id="button_perpage">
                    <span class="icon-publish"></span>
                    <?php echo JText::_('COM_DROPPICS_LAYOUT_DROPPICS_EDIT_IMAGE_RESIZE') ?>
                </button>
            </div>
            <div class="tablenav-pages">
                <?php echo $this->pagination->getListFooter(); ?>
            </div>
            <br class="clear">
        </div>
    </form>
</div>