<?php
/**
 * Droppics
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droppics
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

// no direct access
defined('_JEXEC') || die;

jimport('joomla.application.component.viewlegacy');

/**
 * Class DroppicsViewPicture
 */
class DroppicsViewPicture extends JViewLegacy
{
    /**
     * State
     *
     * @var type
     */
    protected $state;
    /**
     * Item
     *
     * @var type
     */
    protected $item;

    /**
     * Form
     *
     * @var type
     */
    protected $form;

    /**
     * Picture
     *
     * @var type
     */
    protected $pic;
    /**
     * Image path
     *
     * @var string
     */
    protected $imgpath;

    /**
     * Display the view
     *
     * @param null $tpl Tpl
     *
     * @return boolean
     */
    public function display($tpl = null)
    {
        $this->_layout = 'edit';
        $imgp_source = droppicsBase::getParam('imgp_source', 'com_droppics');
        $this->state = $this->get('State');
        $this->item = $this->get('Item');
        $this->form = $this->get('Form');
        $componentParams = JComponentHelper::getParams('com_droppics');
        if (empty($this->item->params)) {
            $this->item->params = $componentParams->toArray();
        } else {
            $this->item->params = array_merge($componentParams->toArray(), $this->item->params);
        }
        $this->canDo = DroppicsHelper::getActions();
        $pmodel = $this->getModel();
        $this->pic = $pmodel->getPicture($this->item->id);
        if (!empty($this->item->params['imgp_source'])) {
            $this->imgpath = $pmodel->getPictureUrl($this->item->params['imgp_source'], $this->item, $this->pic);
        } else {
            $this->imgpath = $pmodel->getPictureUrl($imgp_source, $this->item, $this->pic);
        }
        // Check for errors.
        $errors = $this->get('Errors');
        if (count($errors)) {
            JFactory::getApplication()->enqueueMessage(implode("\n", $errors), 'error');
            return false;
        }

        parent::display($tpl);
    }
}
