<?php
/**
 * Droppics
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droppics
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

// no direct access
defined('_JEXEC') || die;
// phpcs:disable Squiz.Classes.ValidClassName.NotCamelCaps -- Default joomla core class name rule

/**
 * Class com_droppicsInstallerScript
 */
class com_droppicsInstallerScript
{
    /**
     * Com_droppicsInstallerScript constructor.
     */
    public function __construct()
    {
        $this->oldRelease = $this->getVersion('com_droppics');
    }

    /**
     * Method to install the component
     *
     * @return void
     */
    public static function install()
    {
        $lang = JFactory::getLanguage();
        $lang->load('com_droppics.sys', JPATH_BASE . '/components/com_droppics', null, true);
        $dbo = JFactory::getDbo();

        $query = 'CREATE TABLE IF NOT EXISTS `#__droppics` (
                        `id` int(11) NOT NULL,
                        `old_id` int(11) NOT NULL DEFAULT "0",
                        `theme` varchar(30) NOT NULL DEFAULT "",
                        `params` text NOT NULL,
                        PRIMARY KEY (`id`)
                        ) ENGINE=MyISAM  DEFAULT CHARSET=utf8';
        $dbo->setQuery($query);
        $dbo->execute();

        $query = 'CREATE TABLE IF NOT EXISTS `#__droppics_pictures` (
                    `id` int(11) NOT NULL AUTO_INCREMENT,
                    `id_gallery` int(11) NOT NULL,
                    `file` varchar(100) NOT NULL,
                    `position` int(11) NOT NULL DEFAULT "0",
                    `title` varchar(512) NOT NULL DEFAULT "",
                    `alt` varchar(512) NOT NULL DEFAULT "",
                    `params` text NOT NULL,
                    `upload_date` datetime NOT NULL DEFAULT "0000-00-00 00:00:00",
                    PRIMARY KEY (`id`),
                    KEY `id_gallery` (`id_gallery`)
                    ) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ';
        $dbo->setQuery($query);
        $dbo->execute();

        $query = 'CREATE TABLE IF NOT EXISTS `#__droppics_custom` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `id_picture` int(11) NOT NULL,
                        `file` varchar(255) NOT NULL,
                        `title` varchar(255) NOT NULL DEFAULT "",
                        `width` int(11) NOT NULL DEFAULT "0",
                        `height` int(11) NOT NULL DEFAULT "0",
                         PRIMARY KEY (`id`)
                    ) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ;';
        $dbo->setQuery($query);
        $dbo->execute();
    }

    /**
     * Method to uninstall the component
     *
     * @return void
     */
    public function uninstall()
    {
        JLoader::register('JControllerLegacy', JPATH_LIBRARIES . 'legacy/controller/legacy.php');
        $session = JFactory::getSession();
        if ($session->get('droppicsUninstall', false) === false) {
            $session->set('droppicsUninstall', true);
            JFactory::getApplication()->enqueueMessage(JText::_('COM_DROPPICS_INSTALLER_UNINSTALL_DB'), 'warning');
            $controller = new JControllerLegacy();
            $controller->setRedirect('index.php?option=com_installer&view=manage&confirm=1');
            $controller->redirect();
        }

        $dbo = JFactory::getDbo();
        $queries = array();
        $queries[] = 'DROP TABLE IF EXISTS `#__droppics`';
        $queries[] = 'DROP TABLE IF EXISTS `#__droppics_pictures`';
        $queries[] = 'DROP TABLE IF EXISTS `#__droppics_custom`';

        foreach ($queries as $query) {
            $dbo->setQuery($query);
            $dbo->execute();
        }
    }

    /**
     * Method to update the component
     *
     * @return void
     */
    public function update()
    {
        $dbo = JFactory::getDbo();

        if (version_compare($this->oldRelease, '1.0.1', 'lt')) {
            $query = 'ALTER IGNORE TABLE `#__droppics` ADD `params` TEXT NOT NULL';
            $dbo->setQuery($query);
            $dbo->execute();
        }
        if (version_compare($this->oldRelease, '2.0.0', 'lt')) {
            jimport('joomla.filesystem.folder');
            $paramsmedia = JComponentHelper::getParams('com_media');
            $COM_MEDIA_BASE = JPATH_ROOT . '/' . $paramsmedia->get('file_path', 'images');

            $query = 'ALTER TABLE `#__droppics` CHANGE `id` `id` INT(11) NOT NULL';
            $dbo->setQuery($query);
            $dbo->execute();

            $query = 'ALTER TABLE `#__droppics` ADD `newid` INT(11) NOT NULL AFTER `id`';
            $dbo->setQuery($query);
            $dbo->execute();

            $query = 'ALTER TABLE  `#__droppics` ADD  `old_id` INT NOT NULL AFTER  `newid` ;';
            $dbo->setQuery($query);
            $dbo->execute();

            $query = 'ALTER TABLE `#__droppics_pictures` ADD `newid_gallery` INT(11) NOT NULL AFTER `id_gallery`';
            $dbo->setQuery($query);
            $dbo->execute();

            $basePath = JPATH_ADMINISTRATOR . '/components/com_droppics';
            require_once $basePath . '/models/category.php';
            $config = array(
                'table_path' => $basePath . '/tables'
            );
            $catmodel = new DroppicsModelCategory($config);

            $query = 'SELECT * FROM #__droppics';
            $dbo->setQuery($query);
            $datas = array();
            foreach ($dbo->loadObjectList() as $category) {
                $datas['id'] = 0;
                $datas['extension'] = 'com_droppics';
                $datas['title'] = $category->name;
                $datas['alias'] = uniqid() . '-droppics';
                $datas['parent_id'] = 1;
                $datas['level'] = 2;
                $datas['published'] = 1;
                $datas['language'] = '*';
                $catmodel->save($datas);

                $newcat = (int)$catmodel->getState('droppicscats.id');
                $query = 'UPDATE `#__droppics` SET newid=' . $newcat . ', old_id=' . (int)$category->id . ' WHERE id=' . (int)$category->id;
                $dbo->setQuery($query);
                $dbo->execute();

                $query = 'UPDATE `#__droppics_pictures` SET newid_gallery=' . $newcat . ' WHERE id_gallery=' . (int)$category->id;
                $dbo->setQuery($query);
                $dbo->execute();

                JFolder::move($category->id, $category->id . '_' . $newcat, $COM_MEDIA_BASE . '/com_droppics/');
            }

            $query = 'ALTER TABLE `#__droppics` DROP `id`, DROP `name`';
            $dbo->setQuery($query);
            $dbo->execute();

            $query = 'ALTER TABLE `#__droppics_pictures` DROP `id_gallery`';
            $dbo->setQuery($query);
            $dbo->execute();

            $query = 'ALTER TABLE `#__droppics` CHANGE `newid` `id` INT(11) NOT NULL';
            $dbo->setQuery($query);
            $dbo->execute();

            $query = 'ALTER TABLE `#__droppics_pictures` CHANGE `newid_gallery` `id_gallery` INT(11) NOT NULL';
            $dbo->setQuery($query);
            $dbo->execute();

            foreach (JFolder::folders($COM_MEDIA_BASE . '/com_droppics/', '^[0-9]+_[0-9]+$') as $folder) {
                $f = explode('_', $folder);
                JFolder::move($folder, $f[1], $COM_MEDIA_BASE . '/com_droppics/');
            }
        }
        if (version_compare($this->oldRelease, '2.0.1', 'lt')) {
            $query = 'CREATE TABLE IF NOT EXISTS `#__droppics_custom` (
                            `id` int(11) NOT NULL AUTO_INCREMENT,
                            `id_picture` int(11) NOT NULL,
                            `file` varchar(255) NOT NULL,
                            `title` varchar(255) NOT NULL,
                            `width` int(11) NOT NULL,
                            `height` int(11) NOT NULL,
                             PRIMARY KEY (`id`)
                  ) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ;';
            $dbo->setQuery($query);
            $dbo->execute();
        }
        if (version_compare($this->oldRelease, '2.0.1', 'eq')) {
            $query = 'ALTER TABLE  `#__droppics` ADD  `old_id` INT NOT NULL AFTER  `id` ;';
            $dbo->setQuery($query);
            $dbo->execute();
        }

        if (version_compare($this->oldRelease, '2.2.0', 'lt')) {
            $query = 'ALTER TABLE  `#__droppics_custom` ADD  `title` varchar(255) NOT NULL AFTER  `file` ;';
            $dbo->setQuery($query);
            $dbo->execute();
        }
        if (version_compare($this->oldRelease, '2.3.0', 'lt')) {
            $query = 'ALTER TABLE `#__droppics_pictures` ADD `upload_date` DATETIME NULL DEFAULT NULL ';
            $dbo->setQuery($query);
            $dbo->execute();
        }

        if (version_compare($this->oldRelease, '3.2.32', 'lt')) {
            $query = 'ALTER TABLE `#__droppics_pictures` MODIFY `title` varchar(512) NOT NULL DEFAULT "",
                        MODIFY `alt` varchar(255) NOT NULL DEFAULT "" ';
            $dbo->setQuery($query);
            $dbo->execute();
        }
        if (version_compare($this->oldRelease, '3.2.7', 'lt')) {
            setcookie('droppics_notice_msg', 1, time() + (86400 * 30), '/');
        }
    }

    /**
     * Method to run before an install/update/uninstall method
     *
     * @param string $type   Type
     * @param object $parent Parent
     *
     * @return boolean
     */
    public function preflight($type, $parent)
    {
        $app = JFactory::getApplication();
        if ($type === 'update') {
            if (version_compare($this->oldRelease, $parent->getManifest()->version, 'gt')) {
                $app->enqueueMessage('You already have a newer version of Droppics', 'warning');
                $controller = new JControllerLegacy();
                $controller->setRedirect('index.php?option=com_installer&view=install');
                $controller->redirect();
                return false;
            }
        } elseif ($type === 'install') {
            // $parent is the class calling this method
            // $type is the type of change (install, update or discover_install)
            $this->release = $parent->getManifest()->version;
            $jversion = new JVersion();
            // abort if the current Joomla release is older
            if (version_compare($jversion->getShortVersion(), '3.7.0', 'lt')) {
                $app->enqueueMessage('Cannot install Droppics component in a Joomla release prior to 3.7.0', 'warning');
                $controller = new JControllerLegacy();
                $controller->setRedirect('index.php?option=com_installer&view=install');
                $controller->redirect();
                return false;
            }
        }
    }

    /**
     * Method to cleanCache
     *
     * @param null    $group     Cache group
     * @param integer $client_id Client ID
     *
     * @return void
     */
    private function cleanCache($group = null, $client_id = 0)
    {
        $conf = JFactory::getConfig();

        $options = array(
            'defaultgroup' => ($group) ? $group : JFactory::getApplication()->input->get('option'),
            'cachebase' => ($client_id) ? JPATH_ADMINISTRATOR . '/cache' : $conf->get('cache_path', JPATH_SITE . '/cache'));

        $cache = JCache::getInstance('callback', $options);
        $cache->clean();
    }

    /**
     * Method to run after an install/update/uninstall method
     *
     * @param string $type   Type
     * @param object $parent Parent
     *
     * @return boolean
     */
    public function postflight($type, $parent)
    {
        $this->cleanCache('_system', 0);
        $this->cleanCache('_system', 1);

        if ($type === 'install') {
            $basePath = JPATH_ADMINISTRATOR . '/components/com_droppics';
            require_once $basePath . '/models/category.php';
            $config = array(
                'table_path' => $basePath . '/tables'
            );
            $catmodel = new DroppicsModelCategory($config);

            $catData = array('id' => 0, 'parent_id' => 1, 'level' => 1, 'extension' => 'com_droppics'
            , 'title' => JText::_('COM_DROPPICS_INSTALLER_NEW_GALLERY'), 'alias' => 'new-gallery', 'published' => 1, 'language' => '*');
            $status = $catmodel->save($catData);
            if (!$status) {
                $app = JFactory::getApplication();
                $app->enqueueMessage('Unable to create default gallery!', 'warning');
            }
        }

        if ($type === 'install' || $type === 'update') {
            // $parent is the class calling this method
            // $type is the type of change (install, update or discover_install)
            JLoader::register('DroppicsInstallerHelper', JPATH_ADMINISTRATOR . '/components/com_droppics/helpers/installer.php');
            JLoader::register('DroppicsBase', JPATH_ADMINISTRATOR.'/components/com_droppics/classes/droppicsBase.php');

            $lang = JFactory::getLanguage();
            $lang->load('com_droppics.sys', JPATH_BASE . '/components/com_droppics', null, true);

            echo '<h2>' . JText::_('COM_DROPPICS_INSTALLER_TITLE') . '</h2>';
            echo JText::_('COM_DROPPICS_INSTALLER_MSG');

            $manifest = $parent->getManifest();
            $extensions = $manifest->extensions;

            $dbo = JFactory::getDbo();
            $query1 = 'SELECT e.element,e.enabled FROM #__extensions AS e WHERE folder = "droppics"';
            $dbo->setQuery($query1);
            $dataExtension = array();

            if ($dbo->execute()) {
                $status = $dbo->loadObjectList();
                $countExtension = count($status);
                for ($i = 0; $i < $countExtension; $i++) {
                    $dataExtension['droppics-' . $status[$i]->element] = $status[$i]->enabled;
                }
            }

            foreach ($extensions->children() as $key => $extension) {
                $folder[$key] = (array)$extension->attributes()->folder;
                if (!isset($dataExtension[$folder[$key][0]])) {
                    $dataExtension[$folder[$key][0]] = '1';
                }

                $enable = $extension->attributes()->enable;

                if ((string)$dataExtension[$folder[$key][0]] === '0') {
                    $enable = false;
                }
                if (DroppicsInstallerHelper::install(JPATH_ADMINISTRATOR . '/components/com_droppics/extensions/' . $folder[$key][0], $enable)) {
//                        JFile::delete(JPATH_ADMINISTRATOR.'/components/com_sponsorshipreward/extensions/'.$xxxxx[$key]);
                    echo '<img style="padding: 5px 10px;" src="' . JURI::root() . '/components/com_droppics/assets/images/tick.png" />' . $folder[$key][0] . ' : ' . JText::sprintf('COM_DROPPICS_INSTALLER_EXT_OK', '') . '<br/>';
                } else {
                    echo '<img style="padding: 5px 10px; src="' . JURI::root() . '/components/com_droppics/assets/images/exclamation.png" />' . $folder[$key][0] . ' : ' . JText::sprintf('COM_DROPPICS_INSTALLER_EXT_NOK', '') . '<br/>';
                }
            }

            //Set the default parameters
            if ($type === 'install') {
                // $component = JComponentHelper::getComponent('com_droppics');
                $db = JFactory::getDbo();
                $query = $db->getQuery(true);
                $query->select('extension_id as id')
                    ->from('#__extensions')
                    ->where('type=' . $db->quote('component'). ' and element=' . $db->quote('com_droppics'));
                $db->setQuery((string)$query);
                $component = $db->loadObject();

                $data['params']['thumbnail_width'] = '180';
                $data['params']['thumbnail_height'] = '180';
                $data['params']['picture_width'] = '800';
                $data['params']['picture_height'] = '600';
                $data['params']['large_width'] = '1200';
                $data['params']['large_height'] = '1000';
                $data['params']['jpg_quality'] = '80';
                $data['params']['showlightboxtitle'] = '1';


                $table = JTable::getInstance('extension');
                // Load the previous Data
                if (!$table->load($component->id)) {
                    return false;
                }
                // Bind the data.
                if (!$table->bind($data)) {
                    return false;
                }

                // Check the data.
                if (!$table->check()) {
                    return false;
                }

                // Store the data.
                if (!$table->store()) {
                    return false;
                }
            }
            echo '<p><img src="https://www.joomunited.com/images/droppics/droppics-summary.gif" alt="Droppics explanation" /></p>';
        }

        // install template
        $sourcePath = JPATH_ADMINISTRATOR . '/components/com_droppics/templates';
        if (!JFolder::exists($sourcePath . '/droppicsfrontend')) {
            echo 'Unable to install droppics template, missing from source ZIP file!<br />';
            $templateExtensionId = false;
        } else {
            $installer = new JInstaller;
            $result = $installer->install($sourcePath . '/droppicsfrontend');

            if (empty($result)) {
                echo 'Error installing droppics template<br />';
            }
        }

        // add a menu type
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('id');
        $query->from('#__menu_types');
        $query->where($db->quoteName('menutype') . '=' . $db->quote('droppics'));
        $db->setQuery($query);
        $menuTypeId = $db->loadResult();
        if (empty($menuTypeId)) {
            if (DroppicsBase::isJoomla40()) {
                $model = new Joomla\Component\Menus\Administrator\Model\MenuModel();
                $menuType = array(
                    'menutype' => 'droppics',
                    'title' => 'Droppics menu',
                    'description' => 'Droppics menu'
                );
                $saved = $model->save($menuType);
            } else {
                include_once JPATH_ADMINISTRATOR . '/components/com_menus/models/menu.php';
                $menuType = array('menutype' => 'droppics', 'title' => 'Droppics menu', 'description' => 'Droppics menu');
                $model = new MenusModelMenu();
                $saved = $model->save($menuType);
            }

            // need to check errors and display message
            if (!$saved) {
                echo 'Error creating Droppics menu type: ' . $model->getError() . '<br />';
            }
        }

        $query = $db->getQuery(true);
        $query->select('id')->from('#__menu')->where($db->quoteName('menutype') . '=' . $db->quote('droppics'));
        $db->setQuery($query);
        $menuItemId = $db->loadResult();
        if (empty($menuItemId)) {
            $query = $db->getQuery(true);
            $query->select('id')->from('#__template_styles')->where($db->quoteName('template') . '=' . $db->quote('droppicsfrontend'));
            $templateStyleId = $db->setQuery($query)->loadResult();

            if (empty($templateStyleId)) {
                echo 'Error reading template style<br />';
            } else {
                // now we can create the menu item.
                // fetch installed Josetta extension id, as menu item needs that
                $query = $db->getQuery(true);
                $query->select('extension_id')->from('#__extensions')->where($db->quoteName('type') . '=' . $db->Quote('component'))
                    ->where($db->quoteName('element') . '=' . $db->Quote('com_droppics'));
                $componentId = $db->setQuery($query)->loadResult();
                if (empty($componentId)) {
                    echo 'Error reading just installed com_droppics extension id, cannot create front end menu item<br />';
                } else {
                    if (DroppicsBase::isJoomla40()) {
                        $model = new Joomla\Component\Menus\Administrator\Model\ItemModel();
                        // prepare menu item record
                        $menuItem = array(
                            'id' => 0,
                            'menutype' => 'dropfiles',
                            'title' => 'Manage Files',
                            'path' => 'manage-files',
                            'link' => 'index.php?option=com_dropfiles&view=manage',
                            'type' => 'component',
                            'component_id' => $componentId,
                            'published' => 1,
                            'parent_id' => 1,
                            'level' => 1,
                            'language' => '*',
                            'template_style_id' => $templateStyleId
                        );
                        $saved = $model->save($menuItem);
                    } else {
                        //  We can't use directly Joomla item model
                        // has it has an hardcoded JPATH_COMPONENT require_once that fails if used
                        // from another extension than com_menus
                        include_once JPATH_ADMINISTRATOR . '/components/com_droppics/helpers/item.php';
                        // prepare menu item record
                        $menuItem = array('id' => 0, 'menutype' => 'droppics', 'title' => 'Manage Images',
                            'link' => 'index.php?option=com_droppics&view=frontmanage', 'type' => 'component', 'component_id' => $componentId,
                            'published' => 1, 'parent_id' => 1, 'level' => 1, 'language' => '*', 'template_style_id' => $templateStyleId);
                        $model = new MenusModelItem();
                        $saved = $model->save($menuItem);
                        $model->getState('item.id');
                    }
                    if (!$saved) {
                        echo 'Error creating Droppics menu item: ' . $model->getError() . '<br />';
                    }
                }
            }
        }

        $dbo = JFactory::getDbo();
        $tables = $dbo->getTableList();
        $app = JFactory::getApplication();
        $prefix = $app->getCfg('dbprefix');
        if (in_array($prefix . 'joomunited_config', $tables)) {
            $query = $dbo->getQuery(true);
            $query->select('*');
            $query->from('#__joomunited_config');
            $dbo->setQuery($query);

            $results = $dbo->loadObject();
            if (!empty($results)) {
                $token = $results->value;
                if (!empty($token)) {
                    $token = str_replace('token=', '', $token);
                    $com_name = $parent->getElement();
                    $script = '<script type="text/javascript">';
                    $script .= 'jQuery(document).ready(function($){';
                    $script .= "jQuery.ajax({
                                                url     :   'index.php?option=" . $com_name . "&task=jutoken.juAddToken',
                                                method    : 'GET',
                                                dataType : 'json',
                                                data    :   {
                                                    'token': '" . $token . "',
                                                }
                                            }).done(function(response){

                                            });";
                    $script .= '});';
                    $script .= '</script>';
                    echo $script;
                }
            }
        }

        return true;
    }

    /**
     * Method to get the version of a component
     *
     * @param string $option Component name
     *
     * @return null
     */
    private function getVersion($option)
    {
        $manifest = self::getManifest($option);
        if ($manifest && property_exists($manifest, 'version')) {
            return $manifest->version;
        }
        return null;
    }

    /**
     * Method to get an object containing the manifest values
     *
     * @param string $option Component name
     *
     * @return object
     */
    private function getManifest($option)
    {
//                $component = JComponentHelper::getComponent($option);
        $dbo = JFactory::getDbo();
        $query = 'SELECT extension_id FROM #__extensions WHERE element=' . $dbo->quote($option) . ' AND type="component"';
        if (!$dbo->setQuery($query)) {
            return false;
        }
        if (!$dbo->execute()) {
            return false;
        }
        $component = $dbo->loadResult();
        if (!$component) {
            return false;
        }
        $table = JTable::getInstance('extension');
        // Load the previous Data
        if (!$table->load($component, false)) {
            return false;
        }
        return json_decode($table->manifest_cache);
    }
}
