<?php
/**
 * Droppics
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droppics
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

defined('_JEXEC') || die;

/**
 * Class DroppicsViewFrontgallery
 */
class DroppicsViewFrontgallery extends JViewLegacy
{
    /**
     * Display
     *
     * @param null $tpl Tpl
     *
     * @return void
     */
    public function display($tpl = null)
    {
        JModelLegacy::addIncludePath(JPATH_ADMINISTRATOR . '/components/com_droppics/models/', 'droppicsModel');
        JModelLegacy::addIncludePath(JPATH_BASE . '/components/com_droppics/models/', 'droppicsModel');

        $model = JModelLegacy::getInstance('Gallery', 'droppicsModel');
        $models = JModelLegacy::getInstance('Frontcategories', 'droppicsModel');
        $modelc = JModelLegacy::getInstance('Frontcategory', 'droppicsModel');

        $id_gallery = JFactory::getApplication()->input->getInt('id_gallery');
        $categories = $models->getCategories($id_gallery);
        $parent = $models->getParent($id_gallery);

        $theme = $model->getGalleryTheme($id_gallery);
        $componentParams = JComponentHelper::getParams('com_droppics');
        //get pictures in correct order by sort by parameter
        if ((int)$componentParams->get('loadthemecategory', 1) === 0) {
            // Register helper class
            JLoader::register('DroppicsComponentHelper', JPATH_ADMINISTRATOR . '/components/com_droppics/helpers/component.php');
            $cat_params = droppicsComponentHelper::loadParams($theme, $componentParams);
            $pictures = $model->getGalleryByPrams($id_gallery, $cat_params, $theme);
        } else {
            $cat_params = $model->getGalleryParams($id_gallery);
            $pictures = $model->getGalleryByPrams($id_gallery, $cat_params, $theme);
        }

        $listchid = array();
        if (!empty($pictures) || !empty($categories)) {
            JPluginHelper::importPlugin('droppics');
            $params_arr = array(array('from_plugin' => false,
                'id_gallery' => $id_gallery, 'theme' => $modelc->getCategoryTheme($id_gallery), 'pictures' => $pictures, 'categories' => $categories, 'parent' => $parent, 'params' => $modelc->getCategoryParams($id_gallery), 'listchid' => $listchid));
            $app = JFactory::getApplication();
            $gallery = $app->triggerEvent('onShowFrontGallery', $params_arr);

            echo $gallery[0];
        }
        JFactory::getApplication()->close();
    }
}
